<html>
<header>
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="-1"></header>
<body>

<?php
include 'registration_data.inc';

/* categories which will show up in the likes/dislikes
 * selection.  Needs to match what's defined for the contest
 */
$categories = array(
					1 => 'Light Lager',
					2 => 'Pilsner',
					3 => 'European Amber Lager',
					4 => 'Dark Lager',
					5 => 'Bock',
					6 => 'Light Hybrid Beer',
					7 => 'Amber Hybrid Beer',
					8 => 'English Pale Ale',
					9 => 'Scottish and Irish Ale',
					10 => 'American Ale',
					11 => 'English Brown Ale',
					12 => 'Porter',
					13 => 'Stout',
					14 => 'India Pale Ale',
					15 => 'German Wheat and Rye Beer',
					16 => 'Belgian and French Ale',
					17 => 'Sour Ale',
					18 => 'Belgian Strong Ale',
					19 => 'Strong Ale',
					20 => 'Fruit Beer',
					21 => 'Spice/Herb/Vegetable Beer',
					22 => 'Smoke-Flavored and Wood-Aged Beer',
					23 => 'Specialty Beer',
					24 => 'Traditional Mead',
					25 => 'Melomel(Fruit Mead)',
					26 => 'Other Mead',
					27 => 'Standard Cider and Perry',
					28 => 'Specialty Cider and Perry'
			);

/* function to escape a value for a csv file if needed
 */
function escapeCSV($str)
	{  
  	if(preg_match("/[,\"\n\r]/", $str) > 0) 
  		{
    	$str = '"'.str_replace('"', '""', $str).'"';
  		}
  
  	if($str == "")
  		{
    	$str = '""';
 		}
  	return $str;
	}
	
	
/* converts an array of data into a CSV file line
 */	
function toCSV ($t)
	{
 	$s ='';
 
  	foreach($t as $key=>$item)
  		{
     	$s .= "," . escapeCSV($item);    
   		}  
	/* remove a leading comma
 	 */
 	$s = substr($s, 1); 
 	$s .= "\n";
  	return $s;
	}
	

function save_the_data($data)
	{
	global $competition_name;
	global $competition_date;
	global $competition_start_time;
	global $filename;
	global $mailto;
	global $send_confirmation_email;
	global $categories;
	
	$important_variables = array(
		'First Name: ' => 'FirstName',
		'Last Name: ' =>'LastName',
		'Participating As: ' => 'aswhat',
		'BJCP ID Number: ' => 'JudgeID',
		'Judge Rank: ' => 'JudgeRank',
		'Phone Number: ' => 'Phone',
		'Email Address: ' =>'Email',
		'Street Address: ' => 'Street',
		'City: ' => 'City',
		'State: ' => 'State',
		'Zip: ' => 'Zip'
		);
		
//	echo "send confirmation email=$send_confirmation_email<br>";
	/* we're going to save this info in two files, one a CSV
	 * with all the data entered, and the other as a tab delimited file
	 * appropriate for importing into HCCP.
	 */
	$ar[] = $data['FirstName'];
	$ar[] = $data['LastName'];
	$ar[] = $data['Street'];
	$ar[] = $data['City'];
	$ar[] = $data['State'];
	$ar[] = $data['Zip'];
	$ar[] = '';
	$ar[] = $data['Phone'];
	$ar[] = $data['aswhat'];   // save judge/steward here for now
	$ar[] = $data['Email'];
	$ar[] = $data['JudgeID'];
	$ar[] = $data['JudgeRank'];
	$ar[] = "";	   // doesn't do anything, I didn't ask for club
							   // but creates a placeholder
	/* get the likes
	 */
	foreach ($data['Likes'] as $lk)
		$s .= $lk . ",";
	$s = rtrim($s, ",");
	$ar[] = $s;
	/* and the dislikes
	 */
	$s = '';
	foreach ($data['Dislikes'] as $lk)
		$s .= $lk . ",";
	$s = rtrim($s, ",");
	$ar[] = $s;
	$ar[] = date("Y-m-d H:I:s");
	foreach ($ar as $a)
		{
		$tabline .= $a . "\t";
		}
	$commaline = toCsv($ar);
	$fn = $filename . ".tab";
	$f = fopen($fn, "a+");
	fwrite($f, $tabline);
	fclose($f);
	$fn = $filename . ".csv";
	$f = fopen($fn, "a+");
	fwrite($f, $commaline);
	fclose($f);
	//echo "$tabline<br><br>$commaline";
	echo "<span style='text-align:center'>Thank you " . $data['FirstName'] . " for agreeing to " . $data['aswhat'] . " in the $competition_name on $competition_date</span><br>";
	$badbeer = isset($data['Dislikes'][0])? $categories[$data['Dislikes'][0]] : 'Something Nasty';
	echo "<br><span style='text-align:center'>Please show up promptly (by $competition_start_time) or we'll make you " . $data['aswhat'] . " $badbeer</span><br>";
	if (isset($mailto) || isset($send_confirmation_email))
		{
		$email_text = "The following registration was received for $competition_name\n\n";
		foreach ($important_variables as $t => $indx)
			$email_text .= $t . $data[$indx] . "\n";
		$email_text .= "Preferred Categories: ";
		foreach($data['Likes'] as $l)
			$email_text .= $l . " ";
		$email_text .= "\nDisliked Categories: ";
		foreach($data['Dislikes'] as $l)
			$email_text .= $l . " ";
		$email_text .= "\n";
		if (isset($mailto))
			{
			$to = $mailto;
			if (isset($send_confirmation_email))
				$to .= "," . $data['Email'];
			}
		else
			$to = $data['Email'];
		mail($to, "$competition_name Registration", $email_text, "From: competition_registration@donotrespond.dnr");
		}
	}
	
	
function build_judges($JudgeRank)
	{
	$judge_ranks = "<select name='JudgeRank'>" .
	"\n\t<option value=''></option>" .
	"\n\t<option value='None'" . ($JudgeRank == 'None' ? " selected": "") . ">None</option>" .
	"\n\t<option value='Experienced'" . ($JudgeRank == 'Experienced' ? " selected": "") . ">Experienced</option>" .
	"\n\t<option value='Professional'" . ($JudgeRank == 'Professional' ? " selected": "") . ">Professional</option>" .
	"\n\t<option value='Apprentice'" . ($JudgeRank == 'Apprentice' ? " selected": "") . ">Apprentice</option>" .
	"\n\t<option value='Recognized'" . ($JudgeRank == 'Recognized' ? " selected": "") . ">Recognized</option>" .
	"\n\t<option value='Certified'" . ($JudgeRank == 'Certified' ? " selected": "") . ">Certified</option>" .
	"\n\t<option value='National'" . ($JudgeRank == 'National' ? " selected": "") . ">National</option>" .
	"\n\t<option value='Master'" . ($JudgeRank == 'Master' ? " selected": "") . ">Master</option>" .
	"\n\t<option value='Grand Master'" . ($JudgeRank == 'Grand Master' ? " selected": "") . ">Grand Master</option>" .
	"</select>";
	return $judge_ranks;
	}
	
function build_categories($vals)
	{
	global $categories;
	if (is_array($vals))
		$vals = array_flip($vals);
	foreach ($categories as $v => $t)
		{
		$cats .= "\n\t<option value='$v'" . (isset($vals[$v])? ' selected' : '') . ">$t</option>";
		}
    $cats .= "\n</select>";
    return $cats;
	}
/*
echo "Post Data=<br>";
print_r($_POST);
echo "<br>";
*/

$complete = false;	
$likes = "<select name='Likes[]' Multiple size='5'>\n" . build_categories($Likes);
$dislikes = "<select name= 'Dislikes[]' Multiple size='5'\n" . build_categories($Dislikes);
echo "<form name='report' id='frm' action='' method='post'>\n";
echo "<center>\n\t<img src=$banner_gif>\n\t<br><h3>$competition_date</h3>\n";

/* See if we have the necessary data
 */
if (isset($SubmitData))
	{
	$complete = true;
	if (!isset($FirstName) || $FirstName == '')
		{
		echo "<span style='color:red; text-align:center'>Please enter a First Name.</span><br>";
		$complete = false;
		}
	if (!isset($LastName) || $LastName == '')
		{
		echo "<span style='color:red; text-align:center'>Please enter a Last Name.</span><br>";
		$complete = false;
		}
	if (!isset($Email) || $Email == '')
		{
		echo "<span style='color:red; text-align:center'>Please enter an Email Address.</span><br>";
		$complete = false;
		}
	if (!isset($Phone) || $Phone == '')
		{
		echo "<span style='color:red; text-align:center'>Please enter a Phone Number.</span><br>";
		$complete = false;
		}
	if (!isset($aswhat) || $aswhat == '')
		{
		echo "<span style='color:red; text-align:center'>Please select Judge or Steward.</span><br>";
		$complete = false;
		}
	}

if ($complete == true)
	{
	save_the_data($_POST);
	exit();
	}
echo "<h3 style='font-family:sans-serif'>Thank you for your interest in judging in the $competition_name.  <br><br>";
echo "Are You interested in assisting as a: <input type='radio' name='aswhat' value='judge'" . ($aswhat == 'judge'? ' checked' : '') . ">Judge or<input type='radio' name='aswhat' value='steward'" . ($aswhat == 'steward'? ' checked' : '') . "> Steward?";
echo "<br><br>PLease fill out the data below and press submit to register.</h3>";


$jr = build_judges($JudgeRank);
echo "<table border='0' summary='registration data' style='font-family:sans-serif'>";
echo "\n<tr>\n\t<th align='right'>* First Name</th><td><input type='text' name='FirstName' value='" . $FirstName . "'>\n\t</td>";
echo "\n\t<th align='right'>* Last Name</th><td><input type='text' name='LastName' value='" . $LastName . "'>\n\t</td>\n</tr>";
echo "\n<tr>\n\t<th align='right'>Judge Rank</th><td>$jr</td>";
echo "\n\t<th align='right'>Judge ID Number</th><td><input type='text' name='JudgeID' value='" . $JudgeID . "'>\n\t</td>\n</tr>";
echo "\n<tr>\n\t<th align='right'>Street Address</th><td><input type='text' size='20' name='Street' value='" . $Street . "'>\n\t</td>";
echo "\n\t<th align='right'>City</th><td><input type='text' name='City' size='20' value='" . $City . "'>\n\t</td>\n</tr>";
echo "\n<tr>\n\t<th align='right'>State</th><td><input type='text' name='State' size='10' value='" . $State . "'>\n\t</td>";
echo "\n\t<th align='right'>Zip</th><td><input type='text' name='Zip' value='" . $Zip . "'>\n\t</td>\n</tr>";
echo "\n<tr>\n\t<th align='right'>* Phone</th><td><input type='text' name='Phone' size='12' value='" . $Phone . "'>\n\t</td>";
echo "\n\t<th align='right'>* Email</th><td><input type='text' name='Email' value='" . $Email . "'>\n\t</td>\n</tr>";
echo "\n<tr>\n\t<th align='right' colspan='2'>Select Categories you would prefer to judge" .
     "<br><span style=font-size:smaller>(You may hold down the control key to select multiple categories)</th>\n\t<td colspan='2'align='right'>$likes</td>\n</tr>";
echo "\n<tr>\n\t<th align='right' colspan='2'>Select Categories you would prefer NOT to judge" .
     "<br><span style=font-size:smaller>(You may hold down the control key to select multiple categories)</th>\n\t<td colspan='2' align='right'>$dislikes</td>\n</tr>";
echo "\n<tr>\n\t<td colspan='4' align='style='font-size:smaller'> * Required Fields\n\t</td>\n</tr>";
echo "\n<tr>\n\t<td colspan='3'><input type='submit' Name='SubmitData' value='Submit My Information to Judge or Steward in the " . $competition_name . "'>\n\t</td>";
echo "\n\t<td>&nbsp;</td>\n</tr>";
echo "\n</table>";
echo "\n</form>";
echo "</center>";
?>

</body>
</html>
